/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the MarkScPermissionAcceptedRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MarkScPermissionAcceptedRequest{}

// MarkScPermissionAcceptedRequest struct for MarkScPermissionAcceptedRequest
type MarkScPermissionAcceptedRequest struct {
	RolloutId string `json:"rollout_id"`
	ChannelId string `json:"channel_id"`
	ScPermissionId string `json:"sc_permission_id"`
	ScOrganizationId string `json:"sc_organization_id"`
}

// NewMarkScPermissionAcceptedRequest instantiates a new MarkScPermissionAcceptedRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMarkScPermissionAcceptedRequest(rolloutId string, channelId string, scPermissionId string, scOrganizationId string) *MarkScPermissionAcceptedRequest {
	this := MarkScPermissionAcceptedRequest{}
	this.RolloutId = rolloutId
	this.ChannelId = channelId
	this.ScPermissionId = scPermissionId
	this.ScOrganizationId = scOrganizationId
	return &this
}

// NewMarkScPermissionAcceptedRequestWithDefaults instantiates a new MarkScPermissionAcceptedRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMarkScPermissionAcceptedRequestWithDefaults() *MarkScPermissionAcceptedRequest {
	this := MarkScPermissionAcceptedRequest{}
	return &this
}

// GetRolloutId returns the RolloutId field value
func (o *MarkScPermissionAcceptedRequest) GetRolloutId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.RolloutId
}

// GetRolloutIdOk returns a tuple with the RolloutId field value
// and a boolean to check if the value has been set.
func (o *MarkScPermissionAcceptedRequest) GetRolloutIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.RolloutId, true
}

// SetRolloutId sets field value
func (o *MarkScPermissionAcceptedRequest) SetRolloutId(v string) {
	o.RolloutId = v
}

// GetChannelId returns the ChannelId field value
func (o *MarkScPermissionAcceptedRequest) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *MarkScPermissionAcceptedRequest) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *MarkScPermissionAcceptedRequest) SetChannelId(v string) {
	o.ChannelId = v
}

// GetScPermissionId returns the ScPermissionId field value
func (o *MarkScPermissionAcceptedRequest) GetScPermissionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ScPermissionId
}

// GetScPermissionIdOk returns a tuple with the ScPermissionId field value
// and a boolean to check if the value has been set.
func (o *MarkScPermissionAcceptedRequest) GetScPermissionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ScPermissionId, true
}

// SetScPermissionId sets field value
func (o *MarkScPermissionAcceptedRequest) SetScPermissionId(v string) {
	o.ScPermissionId = v
}

// GetScOrganizationId returns the ScOrganizationId field value
func (o *MarkScPermissionAcceptedRequest) GetScOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ScOrganizationId
}

// GetScOrganizationIdOk returns a tuple with the ScOrganizationId field value
// and a boolean to check if the value has been set.
func (o *MarkScPermissionAcceptedRequest) GetScOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ScOrganizationId, true
}

// SetScOrganizationId sets field value
func (o *MarkScPermissionAcceptedRequest) SetScOrganizationId(v string) {
	o.ScOrganizationId = v
}

func (o MarkScPermissionAcceptedRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MarkScPermissionAcceptedRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["rollout_id"] = o.RolloutId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["sc_permission_id"] = o.ScPermissionId
	toSerialize["sc_organization_id"] = o.ScOrganizationId
	return toSerialize, nil
}

type NullableMarkScPermissionAcceptedRequest struct {
	value *MarkScPermissionAcceptedRequest
	isSet bool
}

func (v NullableMarkScPermissionAcceptedRequest) Get() *MarkScPermissionAcceptedRequest {
	return v.value
}

func (v *NullableMarkScPermissionAcceptedRequest) Set(val *MarkScPermissionAcceptedRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableMarkScPermissionAcceptedRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableMarkScPermissionAcceptedRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMarkScPermissionAcceptedRequest(val *MarkScPermissionAcceptedRequest) *NullableMarkScPermissionAcceptedRequest {
	return &NullableMarkScPermissionAcceptedRequest{value: val, isSet: true}
}

func (v NullableMarkScPermissionAcceptedRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMarkScPermissionAcceptedRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


